//-----------------------------------------------------------------------------
//
// PictBear <Filter/Import/Export> Plugin Header File
//
// $Version 1.3 (last modified: 2003/05/04)
//
//                                Copyright(C) 1999-2003 by Yasuyuki Kashiwagi.
//                                                         All Rights Reserved.
//
//-----------------------------------------------------------------------------

#ifndef __PBPLUGIN_H
#define __PBPLUGIN_H

#include <windows.h>

#ifdef __cplusplus
extern "C" {
#endif


///////////////////////////////////////////////////////////////////////////////
// PictBear Ŏgpff[^

typedef union tagPixel32 
{
	DWORD color; // J[l

	struct 
	{
		BYTE b;  // (Blue)
		BYTE g;  // (Green)
		BYTE r;  // (Red)
		BYTE a;  // sx(Opacity)
	} item;
} Pixel32;

typedef Pixel32;


///////////////////////////////////////////////////////////////////////////////
// vOCp萔

//#define PBPLUGIN_VERSION		0		// o[W݊

#define PBPLUGIN_FILTER_VERSION	0x00	// tB^vOC̃o[W
#define PBPLUGIN_IMPORT_VERSION	0x00	// C|[gvOC̃o[W
#define PBPLUGIN_EXPORT_VERSION	0x00	// GNX|[gvOC̃o[W

#define PBPLUGIN_UNKNOWN		0x00	// sȃvOC
#define PBPLUGIN_FILTER			0x01	// tB^vOC
#define PBPLUGIN_IMPORT			0x02	// C|[gvOC
#define PBPLUGIN_EXPORT			0x03	// GNX|[gvOC

#define PBF_MASK_CLIENT			0x00	// }XN PictBear 
#define PBF_MASK_PLUGIN			0x01	// }XN̓vOC


///////////////////////////////////////////////////////////////////////////////
// tB^vOC Version 0x00 pis󋵂ʒm֐

typedef int (WINAPI *PBF_ProgressCallback)(int, int, long);


///////////////////////////////////////////////////////////////////////////////
// PBF_QueryClientInfo (PictBear e𓾂)

typedef BOOL (WINAPI* PBF_QueryClientInfoProc)(DWORD, void*);

#define PBF_QUERY_VERSION		0x00	// int    : PictBear ̃o[W
#define PBF_QUERY_DRAWCOLOR		0x01	// Pixel32: `F
#define PBF_QUERY_BKGNDCOLOR	0x03	// Pixel32: wiFia ̒l͕sj
#define PBF_QUERY_FGCOLOR		0x01	// PBF_QUERY_DRAWCOLOR Ɠ
#define PBF_QUERY_BGCOLOR		0x03	// PBF_QUERY_BKGNDCOLOR Ɠ

// ȉ Version 1.40 ȍ~ŃT|[g(QUERY_VERSION ł͔fs)
#define PBF_QUERY_MASK			0x04	// BYTE*  : }XN̈ւ̃|C^
#define PBF_QUERY_ABORT			0x05	// p[^

// ȉ Version 1.60 ȍ~ŃT|[g
#define PBF_QUERY_EDIT_MODE		0x06	// BYTE   : MASK==0, IMAGE==1


//////////////////////////////////////////////////////////////////////////////
// C[[h

#define LM_NORMAL		0X00	// ʏ
#define LM_PLUS			0X01	// Z
#define LM_MINUS		0X02	// Z
#define LM_TIMES		0X03	// Z
#define LM_SCREEN		0X04	// XN[
#define LM_OVERLAY		0X05	// I[o[C
#define LM_HARDLIGHT	0X06	// n[hCg
#define LM_SOFTLIGHT	0X07	// \tgCg
#define LM_OVER			0X08	// Ă
#define LM_FIRE			0X09	// Ă
#define LM_CMPLIGHT		0X0A	// r()
#define LM_CMPDARK		0X0B	// r()
#define LM_ABS			0X0C	// ̐Βl
#define LM_EXCEPT		0X0D	// O
#define LM_VIVIDLIGHT	0X0E	// rrbgCg
#define LM_LINEARLIGHT	0X0F	// jACg
#define LM_PINLIGHT		0X10	// sCg


//////////////////////////////////////////////////////////////////////////////
// C[W^Cv

#define IT_MONO			0X01	// mN
#define IT_GRAYSCALE	0X02	// O[XP[
#define IT_INDEXCOLOR	0X03	// CfbNX[h	
#define IT_FULLCOLOR	0X04	// tJ[


//////////////////////////////////////////////////////////////////////////////
// C[\(C|[g XProvidedFunc ŃANZXĂ)

typedef struct tagPLayer
{
	char*  m_pszName;		// O
	int    m_nLayerMode;	// [h
	int    m_bVisible;		// 
	int    m_nOpacity;		// sx
	int    m_nLeft;			// ItZbg
	int    m_nTop;			// ItZbg
	int    m_nWidth;		// 
	int    m_nHeight;		// 
	DWORD* m_pData;			// C[f[^
} PLayer;


//////////////////////////////////////////////////////////////////////////////
// C[W\(C|[g XProvidedFunc ŃANZXĂ)

typedef struct tagPImage
{
	int     nImageType;			// C[W^Cv(IT_XXXX)

	PLayer* pLayer;				// C[ff[^
	int     nLayerCount;		// C[̐ (1 `)
	int     nWidth;				// C[W̕
	int     nHeight;			// C[W̍
	int     bEnableBg;			// wiC[gp邩(tJ[)

	Pixel32 rgbPalettes[256];	// pbg
	int     nPaletteSize;		// pbgTCY
	int     nTransparent;		// ߐFԍ
	int     bEnableTrans;		// ߐFL
} PImage;


//////////////////////////////////////////////////////////////////////////////
// PictBear 񋟂֐
// C|[gvOCŎgpĂB

//typedef int (WINAPI *PBF_ProgressCallback)(int, int, long);

typedef void (WINAPI *PBI_CreateMono)(PImage* pImage, int nWidth, int Height);
typedef void (WINAPI *PBI_CreateGrayScale)(PImage* pImage, int nWidth, int nHeight);
typedef void (WINAPI *PBI_CreateIndexColor)(PImage* pImage, int nWidth, int nHeight);
typedef void (WINAPI *PBI_CreateFullColor)(PImage* pImage, int nWidth, int nHeight, int bEnableBgLayer);

typedef void (WINAPI *PBI_AddLayer)(
		PImage* pImage, LPCTSTR szName, int nMode, int bVisible, int nOpacity, 
		int nWidth, int nHeight, int nLeftOffset, int nTopOffset);
typedef void (WINAPI *PBI_ResizeBgLayer)(PImage* pImage, int nWidth, int nHeight, int nLeftOffset, int nTopOffset);

typedef void (WINAPI *PBI_SetData)(PImage* pImage, int nLayer, int x, int y, DWORD dwData);
typedef DWORD (WINAPI *PBI_GetData)(PImage* pImage, int nLayer, int x, int y);


struct XProvidedFunc
{
	// C[W̍쐬֐B
	PBI_CreateMono			CreateMono;
	PBI_CreateGrayScale		CreateGrayScale;
	PBI_CreateIndexColor	CreateIndexColor;
	PBI_CreateFullColor		CreateFullColor;

	// C[
	PBI_AddLayer			AddLayer;
	PBI_ResizeBgLayer		ResizeBgLayer;

	// f[^p֐
	PBI_SetData				SetData;
	PBI_GetData				GetData;
};


#ifdef __cplusplus
}
#endif


#endif // __PBPLUGIN_H
//-----------------------------------------------------------------------------
