//-----------------------------------------------------------------------------
// Color Filters
// Copyright (C) 2000-2003 by Yasuyuki Kashiwagi. All Rights Reserved.
//-----------------------------------------------------------------------------

#include "Color.h"


ReverseFilter::ReverseFilter()
{
	int kernel[25] = 
	{
		0, 0, 0, 0, 0,
		0, 0, 0, 0, 0,
		0, 0,-1, 0, 0,
		0, 0, 0, 0, 0,
		0, 0, 0, 0, 0
	};

	SetKind("Color|J[");
	SetName("Reverse|K̔]");
	SetKernel(kernel);
	SetScale(1);
	SetOffset(255);
}

ContrastPlusFilter::ContrastPlusFilter()
{
	int kernel[25] = 
	{
		0, 0, 0, 0, 0,
		0, 0, 0, 0, 0,
		0, 0, 5, 0, 0,
		0, 0, 0, 0, 0,
		0, 0, 0, 0, 0
	};

	SetKind("Color|J[");
	SetName("Contrast +25%|RgXg +25%");
	SetKernel(kernel);
	SetScale(4);
	SetOffset(-32);
}

ContrastMinusFilter::ContrastMinusFilter()
{
	int kernel[25] = 
	{
		0, 0, 0, 0, 0,
		0, 0, 0, 0, 0,
		0, 0, 3, 0, 0,
		0, 0, 0, 0, 0,
		0, 0, 0, 0, 0
	};

	SetKind("Color|J[");
	SetName("Contrast -25%|RgXg -25%");
	SetKernel(kernel);
	SetScale(4);
	SetOffset(32);
}

GrayScaleFilter::GrayScaleFilter()
{
	SetKind("Color|J[");
	SetName("GrayScale|OCXP[");
}

void GrayScaleFilter::Execute(ExecuteArg* arg)
{
	RECT rec = *(arg->area);

	ProgressStart(arg, rec.bottom - rec.top);
	for (int y=rec.top; y<rec.bottom; y++) 
	{
		for (int x=rec.left; x<rec.right; x++) 
		{
			const Pixel32* srcp = &(arg->src[x + y*arg->width]);
			Pixel32* dstp       = &(arg->dst[x + y*arg->width]);

			if (srcp->item.a > 0) 
			{
				BYTE gray = (srcp->item.r + srcp->item.g + srcp->item.b)/3;
				dstp->item.r = gray;
				dstp->item.g = gray;
				dstp->item.b = gray;
			}
		} 
		ProgressSetPos(arg, y - rec.top);
	}
	ProgressEnd(arg);
}
