//-----------------------------------------------------------------------------
// Kernel
// Copyright (C) 2000-2003 by Yasuyuki Kashiwagi. All Rights Reserved.
//-----------------------------------------------------------------------------

#include "CustomFilter.h"


CustomFilter::CustomFilter()
{
	SetSupportedFormat(PBF_TYPE_FULLCOLOR);

	SetScale(1);
	SetOffset(0);
	ClearKernel();
}

CustomFilter::~CustomFilter()
{
}

void CustomFilter::Execute(ExecuteArg* arg)
{
	RECT rec = *(arg->area);

	ProgressStart(arg, rec.bottom - rec.top);
	for (int y=rec.top; y<rec.bottom; y++) 
	{
		for (int x=rec.left; x<rec.right; x++) 
		{
			int px, py;
			int r, g, b, i;

			r = g = b = i = 0;

			// 5x5 ̃J[lɑ΂
			for (py=-2; py<=2; py++) 
			{
				for ( px=-2; px<=2; px++) 
				{
					int lx = x + px;
					int ly = y + py;

					// ʒ[̏
					if (lx < 0)                lx = 0;
					else if (lx >= arg->width) lx = arg->width - 1;

					if (ly < 0)                 ly = 0;
					else if (ly >= arg->height) ly = arg->height - 1;

					int pos = lx + ly*arg->width;
					r = r + m_nKernel[i]*arg->src[pos].item.r;
					g = g + m_nKernel[i]*arg->src[pos].item.g;
					b = b + m_nKernel[i]*arg->src[pos].item.b;
					++i;
				}
			}

			r = r/m_nScale + m_nOffset;
			g = g/m_nScale + m_nOffset;
			b = b/m_nScale + m_nOffset;

			r = min(255, max(r, 0));
			g = min(255, max(g, 0));
			b = min(255, max(b, 0));

			int pos = x + y*arg->width;
			arg->dst[pos].item.r = (BYTE)r;
			arg->dst[pos].item.g = (BYTE)g;
			arg->dst[pos].item.b = (BYTE)b;
		}
		ProgressSetPos(arg, y - rec.top);
	}
	ProgressEnd(arg);
}
