//-----------------------------------------------------------------------------
// Custom Filter
// Copyright (C) 2000-2004 by Yasuyuki Kashiwagi. All Rights Reserved.
//-----------------------------------------------------------------------------

#if !defined(__CUSTOMFILTER_H)
#define      __CUSTOMFILTER_H

#if !defined(__GENFILTER_H)
#include "GenFilter.h"
#endif


class CustomFilter : public FilterBase 
{
protected:
	int  m_nScale;
	int  m_nOffset;
	int  m_nKernel[25];

protected:
	void SetScale(int n)        { m_nScale = n; };
	void SetOffset(int n)       { m_nOffset = n; };
	void SetKernel(int* kernel) { memcpy(m_nKernel, kernel, sizeof(int)*25); }
	void ClearKernel()          { memset(m_nKernel, 0, sizeof(int)*25); }
	int  GetScale() const       { return m_nScale; }
	int  GetOffset() const      { return m_nOffset; }

public:
	CustomFilter();
	virtual ~CustomFilter();

	virtual void Execute(ExecuteArg* arg);
};


#endif // __CUSTOMFILTER_H
