//-----------------------------------------------------------------------------
// Edge Filters
// Copyright (C) 2000-2003 by Yasuyuki Kashiwagi. All Rights Reserved.
//-----------------------------------------------------------------------------

#include "Edge.h"


EdgePrewittFilter::EdgePrewittFilter()
{
	int kernel[25] = 
	{
		0, 0, 0, 0, 0,
		0, 1, 1, 1, 0,
		0, 1,-2,-1, 0,
		0, 1,-1,-1, 0,
		0, 0, 0, 0, 0
	};

	SetKind("Edge|GbWo");
	SetName("Prewitt|vEBbg@");
	SetKernel(kernel);
	SetScale(1);
	SetOffset(0);
}

EdgeLaplacianFilter::EdgeLaplacianFilter()
{
	int kernel[25] = 
	{
		0, 0, 0, 0, 0,
		0,-1,-1,-1, 0,
		0,-1, 8,-1, 0,
		0,-1,-1,-1, 0,
		0, 0, 0, 0, 0
	};

	SetKind("Edge|GbWo");
	SetName("Laplacian|vVA@");
	SetKernel(kernel);
	SetScale(1);
	SetOffset(0);
}
