//-----------------------------------------------------------------------------
// PictBear Import Bitmap Plugin
// Copyright (C) 2000-2003 by Yasuyuki Kashiwagi. All Rights Reserved.
//
// $Version 1.00 [2003/05/05]
//
// Windows Bitmap ǂݍރC|[gvOCłB
//
// Visual C++ 6.0 ł̓mFĂ܂B
// >cl /LD /FeimpBmp.ppi impBmp.c
//
// ̃\[X̉ρEzz͎RɍsĂBsC͑劽}łB
//-----------------------------------------------------------------------------

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include "../../PbPlugin.h"

#ifdef __cplusplus
#define DLLExport extern "C" __declspec (dllexport)
#else
#define DLLExport __declspec (dllexport)
#endif


// TODO: P̃vOCɂ͕̊gqo^ł܂B
//       o^gq̐`ĂB
#define SUPPORTED_TYPE_IN_PLUGIN 1

// TODO: Ήgq gq|p|{ Œ`ĂBgq
//       Ƀhbg͂ȂŉB̊gqo^ꍇ ';' ŋ؂
//       ĂB
//
//       gq̏ꍇ̓C|[gj[ɕ\܂B[TWAIN @킩
//       ǂݍ]̂悤Ƀt@CȊOC|[gꍇɗpł܂B
const char* g_szTypes[SUPPORTED_TYPE_IN_PLUGIN] = 
{
	"bmp;dib|Windows Bitmaps Files|Windows rbg}bvt@C"
};


// TODO: Cӂ̃Rs[Cgݒ肵ĂB
const char* g_szCopyright = "Copyright (C) 2000-2003 by Yasuyuki Kashiwagi. All Rights Reserved.";


HINSTANCE g_hInstance;


///////////////////////////////////////////////////////////////////////////////
// Gg[|Cg

BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
	if (fdwReason == DLL_PROCESS_ATTACH) 
		g_hInstance = hinstDLL;
	
	return TRUE;
}


///////////////////////////////////////////////////////////////////////////////
// vOC擾

DLLExport WORD WINAPI PB_GetPluginInfo(LPSTR buf, int buflen)
{
	// TODO: buf ɃRs[Cgݒ肵Aȉ̒lԂĂB
	strncpy(buf, g_szCopyright, buflen);

	return MAKEWORD(PBPLUGIN_IMPORT, PBPLUGIN_IMPORT_VERSION);
}


///////////////////////////////////////////////////////////////////////////////
// ΉĂgq̐擾

DLLExport int WINAPI PBI_GetCount(void)
{
	// TODO: vOCɑΉĂgq̐ԂĂB
	return SUPPORTED_TYPE_IN_PLUGIN;
}


///////////////////////////////////////////////////////////////////////////////
// ΉĂt@C̏ڍׂ擾

DLLExport void WINAPI PBI_GetSupportedType(int nIndex, LPSTR szType, int nSize)
{
	// TODO: szTypes ɑΉĂgqݒ肵ĂB
	strncpy(szType, g_szTypes[nIndex], nSize);
}


///////////////////////////////////////////////////////////////////////////////
// C|[gs

DLLExport int WINAPI PBI_Execute(int nIndex, HWND hWnd, LPCSTR szFileName, PImage* pImage, PProvidedFunc* pFunc)
{
	// TODO: C|[g̓eLqĂB
	BITMAPFILEHEADER bf;
	DWORD            dwInfoSize;
	BITMAPINFOHEADER bi; // for Win3.1
	BITMAPCOREHEADER bc; // for OS/2
	RGBQUAD*         pal;
	FILE*            fp;
	BYTE*            buf;
	BYTE             bZeroIsBlack; // mNC[W 0 , 1 Ȃ true
	
	int nPaletteSize;
	int nLineNeed;
	int nWidth;
	int nHeight;
	int nBitCount;
	int nClrUsed;
	int i;

	if ((fp = fopen(szFileName, "rb")) == NULL)
		return PB_ERR_FILE_NOT_FOUND;

	// BITMAPFILEHEADER ǂݍށB
	fread(&bf, sizeof(BITMAPFILEHEADER), 1, fp);

	if (bf.bfType != 0x4d42)
	{
		fclose(fp);
		return PB_ERR_BAD_FORMAT;
	}

	// BITMAPINFOHEADER ǂݍ݂ށB
	fread(&dwInfoSize, sizeof(DWORD), 1, fp);
	fseek(fp, -(long)sizeof(DWORD), SEEK_CUR);

	if (dwInfoSize == sizeof(BITMAPCOREHEADER))
	{
		fread(&bc, sizeof(BITMAPCOREHEADER), 1, fp);

		nBitCount = bc.bcBitCount;
		nWidth    = bc.bcWidth;
		nHeight   = bc.bcHeight;
		nClrUsed  = 0;
	}
	else
	{
		fread(&bi, sizeof(BITMAPINFOHEADER), 1, fp);

		nBitCount = bi.biBitCount;
		nWidth    = bi.biWidth;
		nHeight   = bi.biHeight;
		nClrUsed  = bi.biClrUsed;
	}

	if (nBitCount == 16 || nBitCount == 32)
	{
		fclose(fp);
		return PB_ERR_BAD_FORMAT;
	}

	switch (nBitCount)
	{
	case 1:
		nPaletteSize = 2;
		pFunc->CreateMono(pImage, nWidth, nHeight);
		break;
	case 4:
		nPaletteSize = 16;
		pFunc->CreateIndexColor(pImage, nWidth, nHeight);
		break;
	case 8:
		nPaletteSize = 256;
		pFunc->CreateIndexColor(pImage, nWidth, nHeight);
		break;
	default:
		nPaletteSize = 0;
		pFunc->CreateFullColor(pImage, nWidth, nHeight, 1, TRUE);
		break;
	}

	if (nClrUsed != 0)
		nPaletteSize = nClrUsed;

	if (nPaletteSize > 0)
	{
		pal = (RGBQUAD*)malloc(sizeof(RGBQUAD)*nPaletteSize);
		fread(pal, sizeof(RGBQUAD), nPaletteSize, fp);

		if (nBitCount != 1)
		{
			pImage->nPaletteSize = nPaletteSize;

			for (i=0; i<nPaletteSize; i++)
			{
				Pixel32 col;
				col.item.r = pal[i].rgbRed;
				col.item.g = pal[i].rgbGreen;
				col.item.b = pal[i].rgbBlue;
				col.item.a = 255;

				pImage->rgbPalettes[i].color = col.color;
			}
		}
		else
		{
			int n0gray = (int)(0.299*pal[0].rgbRed + 0.587*pal[0].rgbGreen + 0.114*pal[0].rgbBlue);
			int n1gray = (int)(0.299*pal[1].rgbRed + 0.587*pal[1].rgbGreen + 0.114*pal[1].rgbBlue);

			if (n0gray < n1gray)
				bZeroIsBlack = TRUE;   // 0 A1 킷B
			else
				bZeroIsBlack = FALSE;  // 1 A0 킷B

			pImage->nPaletteSize = 0;
		}
	}
	else
	{
		pal = NULL;
		pImage->nPaletteSize = 0;
	}

	pFunc->ProgressStart(0, nHeight);

	// CpoCgvZADWORD 񉻂sB
	nLineNeed = (nWidth*nBitCount)/8;
	if (nLineNeed % 4)
		nLineNeed = ((nLineNeed/4) + 1)*4;

	buf = (BYTE*)malloc(sizeof(BYTE)*nLineNeed);

	for (i=0; i<nHeight; i++)
	{
		int x, y;
		
		if (fread(buf, sizeof(BYTE), nLineNeed, fp) != (size_t)nLineNeed)
		{
			// ǂݍݒɃG[̂łׂĔjB
			if (pal) 
				free(pal);
			free(buf);
			fclose(fp);
			
			return PB_ERR_BAD_FORMAT;
		}

		y = nHeight - i - 1;

		// F[xɂ͂sB
		switch (nBitCount)
		{
		case 1:
			for (x=0; x<nLineNeed; x++)
			{
				int bit;
				
				for (bit=0; bit<8; bit++)
				{
					if (x*8+bit < nWidth)
					{
						DWORD data = (DWORD) (((buf[x] >> (7-bit)) & 1) ? 1 : 0);
						if (bZeroIsBlack)
							pFunc->SetData(pImage, 0, x*8 + bit, y, data);
						else
							pFunc->SetData(pImage, 0, x*8 + bit, y, 1 - data);
					}
				}
			}
			break;

		case 4:
			for (x=0; x<nLineNeed; x++)
			{
				DWORD data2 = buf[x] & 0x0F;
				DWORD data1 = buf[x] >> 4;

				pFunc->SetData(pImage, 0, x*2 + 0, y, data1);

				if (x*2+1 < nWidth)
					pFunc->SetData(pImage, 0, x*2 + 1, y, data2);
			}
			break;

		case 8:
			for (x=0; x<nWidth; x++)
				pFunc->SetData(pImage, 0, x, y, (DWORD)buf[x]);
			break;

		case 16:
			break;

		case 24:
			for (x=0; x<nWidth; x++)
			{
				Pixel32 col;
				col.item.r = buf[x*3+2];
				col.item.g = buf[x*3+1];
				col.item.b = buf[x*3+0];
				col.item.a = 255;
				pFunc->SetData(pImage, 0, x, y, col.color);
			}
			break;

		case 32:
			for (x=0; x<nWidth; x++)
			{
				Pixel32 col;
				col.item.r = buf[x*3+3];
				col.item.g = buf[x*3+2];
				col.item.b = buf[x*3+1];
//				col.item.a = buf[x*3+0];
				col.item.a = 255;
				pFunc->SetData(pImage, 0, x, y, col.color);
			}
			break;
		}

		pFunc->ProgressSetPos(i);
	}

	pFunc->ProgressEnd();

	if (pal) 
		free(pal);
	free(buf);

	fclose(fp);

	return PB_ERR_SUCCESS;
}


///////////////////////////////////////////////////////////////////////////////
// vOC̐ݒ

/*

DLLExport void WINAPI PBI_Setup(HWND hWnd, PProvidedFunc* pFunc)
{
	// TODO: vOC̐ݒs܂B
}

*/


///////////////////////////////////////////////////////////////////////////////
// Visual C++ p GNX|[g̕ϊ

#ifdef _MSC_VER
#pragma comment(linker, "/EXPORT:PB_GetPluginInfo=_PB_GetPluginInfo@8")
#pragma comment(linker, "/EXPORT:PBI_GetCount=_PBI_GetCount@0")
#pragma comment(linker, "/EXPORT:PBI_GetSupportedType=_PBI_GetSupportedType@12")
#pragma comment(linker, "/EXPORT:PBI_Execute=_PBI_Execute@20")
//#pragma comment(linker, "/EXPORT:PBI_Setup=_PBI_Setup@8")
#endif

